// TSML.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "TSML.h"

#include "MainFrm.h"
#include "ChildFrm.h"
//#include "ChildPicFrm.h"
#include "TSMLSet.h"
#include "TSMLDoc.h"
#include "TSMLView.h"
#include "TSMLPicView.h"
#include "MyFormView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTSMLApp

BEGIN_MESSAGE_MAP(CTSMLApp, CWinApp)
//{{AFX_MSG_MAP(CTSMLApp)
ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
ON_COMMAND(ID_VIEW1, OnView1)
ON_COMMAND(ID_VIEW2, OnView2)
//}}AFX_MSG_MAP
// Standard file based document commands
ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
// Standard print setup command
ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTSMLApp construction

CTSMLApp::CTSMLApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTSMLApp object

CTSMLApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CTSMLApp initialization

BOOL CTSMLApp::InitInstance()
{
	AfxEnableControlContainer();
	
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.
	
#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif
	
	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)
	
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.
	
	pDocTemplate = new CMultiDocTemplate(
		IDR_TSMLTYPE,
		RUNTIME_CLASS(CTSMLDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CTSMLView));
	AddDocTemplate(pDocTemplate);
	
	pDocTemplate1 = new CMultiDocTemplate(
		IDR_TSMLPICTYPE,
		RUNTIME_CLASS(CTSMLDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CTSMLPicView));
	AddDocTemplate(pDocTemplate1);
	
	
	// create main MDI Frame window
	/*	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
	return FALSE;
	m_pMainWnd = pMainFrame;
	*/
	
	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	mp_doc=new CTSMLDoc;
	mp_doc->SetTitle("Just a demo");
	CCreateContext context;
	context.m_pCurrentDoc=mp_doc;
	context.m_pNewViewClass=NULL;
	context.m_pNewDocTemplate=NULL;
	context.m_pLastView=NULL;
	context.m_pCurrentFrame=NULL;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME,WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE,NULL, &context ))
		return FALSE;
	m_pMainWnd = pMainFrame;
	
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	
	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	
	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	
	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//{{AFX_MSG_MAP(CAboutDlg)
// No message handlers
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CTSMLApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CTSMLApp message handlers


void CTSMLApp::OnView1() 
{
	// TODO: Add your command handler code here
/*
	CWnd *pChildFrm=m_pMainWnd->GetWindow(GW_CHILD);

	while(!(pChildFrm==NULL))
	{
		pChildFrm=pChildFrm->GetWindow(GW_HWNDNEXT);
		if(pChildFrm->IsKindOf(RUNTIME_CLASS(CChildFrame)))
		{
			pChildFrm=(CChildFrame *)pChildFrm;
			CView *pMyView=(CChildFrame *)pChildFrm->GetActiveView();
			if(pMyView->IsKindOf(RUNTIME_CLASS(CTSMLView))) 
			{
				return;
			}
		}
	}
*/
	CChildFrame* pFrame = new CChildFrame();
	CCreateContext context;
	context.m_pCurrentDoc=mp_doc; //that's the way I avoid to create new document every time I open a new view
	context.m_pNewViewClass=RUNTIME_CLASS(CTSMLView);
	context.m_pNewDocTemplate=pDocTemplate;
	context.m_pLastView=(((CMainFrame *)m_pMainWnd)->GetActiveFrame() ? ((CMainFrame *)m_pMainWnd)->GetActiveFrame()->GetActiveView() : NULL);
	context.m_pCurrentFrame=((CMainFrame *)m_pMainWnd)->GetActiveFrame();
	if (!pFrame->LoadFrame(IDR_TSMLTYPE,WS_OVERLAPPEDWINDOW | FWS_PREFIXTITLE ,m_pMainWnd, &context ))return;
	pFrame->InitialUpdateFrame(mp_doc,TRUE);
}

void CTSMLApp::OnView2() 
{
	CChildFrame* pFrame = new CChildFrame();
	CCreateContext context;
	context.m_pCurrentDoc=mp_doc; //that's the way I avoid to create new document every time I open a new view
	context.m_pNewViewClass=RUNTIME_CLASS(CTSMLPicView);
	context.m_pNewDocTemplate=pDocTemplate;
	context.m_pLastView=(((CMainFrame *)m_pMainWnd)->GetActiveFrame() ? ((CMainFrame *)m_pMainWnd)->GetActiveFrame()->GetActiveView() : NULL);
	context.m_pCurrentFrame=((CMainFrame *)m_pMainWnd)->GetActiveFrame();
	if (!pFrame->LoadFrame(IDR_TSMLPICTYPE,WS_OVERLAPPEDWINDOW | FWS_PREFIXTITLE ,m_pMainWnd, &context ))return;
	pFrame->InitialUpdateFrame(mp_doc,TRUE);
}
